package com.jty.wsxt.application.service.impl;

import com.jty.wsxt.application.service.PaperService;
import com.jty.wsxt.domain.DomainRegistry;
import com.jty.wsxt.domain.model.paper.Paper;
import com.jty.wsxt.infrastructure.support.BusinessException;
import com.jty.wsxt.infrastructure.support.ResultCode;
import com.jty.wsxt.interfaces.dto.PaperDto;
import com.jty.wsxt.interfaces.dto.PaperSearchDto;
import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.BeanUtils;
import org.springframework.data.domain.Example;
import org.springframework.data.domain.ExampleMatcher;
import org.springframework.data.domain.Page;
import org.springframework.stereotype.Service;
import com.alibaba.fastjson.JSON;

/**
 * PaperServiceImpl
 *
 * @author Manjiajie
 * @since 2019-6-21 11:38:06
 */
@Service
public class PaperServiceImpl implements PaperService {
    @Override
    public void addPaper(PaperSearchDto paperSearchDto) {
        Paper paper = new Paper();
        BeanUtils.copyProperties(paperSearchDto,paper,"answer","firstFeedback","secondFeedback");
        paper.setAnswer(JSON.toJSONString(paperSearchDto.getAnswer()));
        paper.save();
    }

    @Override
    public Page<Paper> findPagePaper(PaperSearchDto paperSearchDto) {
        Paper paper = new Paper();
        if(paperSearchDto.getModuleId() != null){
            paper.setModuleId(paperSearchDto.getModuleId());
        }
        if(paperSearchDto.getSubjectId() != null){
            paper.setSubjectId(paperSearchDto.getSubjectId());
        }
        if(paperSearchDto.getTypeId() != null){
            paper.setTypeId(paperSearchDto.getTypeId());
        }
        ExampleMatcher matcher = ExampleMatcher.matching().withMatcher("name",ExampleMatcher.GenericPropertyMatchers.contains());
        Example<Paper> example = Example.of(paper,matcher);

        return DomainRegistry.paperRepository().findAll(example,paperSearchDto.getPageable());
    }

    @Override
    public void deletePaper(Integer paperId) {
        Paper paper = DomainRegistry.paperRepository().findById(paperId).orElseThrow(()->new BusinessException(ResultCode.RESULT_DATA_NONE));
        paper.delete();
    }
}
